<?php

class kWhatsappLibrary {
    public $username; // This username
    public $password; // This Password
    public $error;    // This error message output
    public $timeout = 200; // This timeout
    public $rid;        // This Report ID
    private $url;        // This Data URL


    public function __construct($username, $password) {
        $this->username = $username;
        $this->password = $password;
        $this->url = "https://wapi.kariha.net/";
    }

    public function Submit($title = NULL, $message = NULL, $number = 0, $kara_liste = NULL) {
        $numbers = is_array($number) ? $number : array($number);

        $numbers = is_array($number) ? implode(',', $number) : $number;

        $params = array(
            'to' => $numbers,
            'body' => $message);

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => $this->url . "/" . $this->username . "/messages/chat?token=" . $this->password,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => http_build_query($params),
            CURLOPT_HTTPHEADER => [
                "accept: application/json"
            ],
        ]);

        $response = curl_exec($curl);
        $error = curl_error($curl);
        curl_close($curl);

        Modules::save_log("SMS", "kWhatsapp", "send", htmlspecialchars(http_build_query($params)), $response);

        if ($response) {
            return $response . " / " . $error;
        } else {
            $this->error = "Boş cevap döndü.";
            return false;
        }

    }

    public function Balance() {
        $return = $this->curl_use($this->url . '/' . $this->username . '/instance/status?token=' . $this->password, '');
        $return = json_decode($return, true);
        if ($return) {
            if($return['status']['accountStatus']['status'] == 'authenticated') { $status = 'Yetkilendirildi'; } else { $status  = $return['status']['accountStatus']['status']; }
            if($return['status']['accountStatus']['substatus'] == 'connected') { $substatus = 'Bağlı'; } else { $substatus = $return['status']['accountStatus']['substatus']; }
            $printOutput = "<b>Durum</b>: " . $status . "<br><b>Alt Durum</b>: " . $substatus;
            if ($return['status']['accountStatus']['status'] == "standby") {
                $printOutput .= "<br>Instance aktif. Bekleme Konumunda. Birkaç saniye sonra tekrar yenileyin. Cihaz uyandırılıyor...";
            }

            if ($return['status']['accountStatus']['status'] == "qr") {
                $printOutput .= "<br>Hangi whatsapp hesabı üzerinden mesaj göndermek istiyorsanız. Lütfen o cihazdan qr kodu okutunuz. ";
                $qr = $this->curl_use($this->url . '/' . $this->username . '/instance/qr?token=' . $this->password, '');
                $printOutput .= '<img src="data:image/png;base64,' . base64_encode($qr) . '">';
            }

            if ($return['status']['accountStatus']['status'] == "authenticated") {
                $printOutput .= "<br><b>Giriş yapılmış. Cihaz bağlanmıştır👍</b>";
            }

            if ($return['status']['accountStatus']['substatus'] == "connected") {
                $infos = $this->curl_use($this->url . '/' . $this->username . '/instance/me?token=' . $this->password, '');
                $infos = json_decode($infos, true);
                $printOutput .= "<br><b>Hesap Numarası</b>: " . str_replace('@c.us', '', $infos['id']) . "<br><b>Hesap Adı</b>: " . $infos['name'] . "";
            }


            return $printOutput;
        } else {
            return "Veri yok";
        }
    }

    private function curl_use($site_url, $post_data) {

        $curl = curl_init();

        curl_setopt_array($curl, [
            CURLOPT_URL => $site_url,
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "GET",
            CURLOPT_HTTPHEADER => [
                "accept: application/json"
            ],
        ]);

        $response = curl_exec($curl);
        $err = curl_error($curl);

        curl_close($curl);

        if ($err) {
            return "cURL Error #:" . $err;
        } else {
            return $response;
        }


    }

}